
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Job_templatesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_templates = await db.job_templates.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        default_price: data.default_price
        ||
        null
            ,
            
        default_duration_minutes: data.default_duration_minutes
        ||
        null
            ,
            
        default_instructions: data.default_instructions
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await job_templates.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await job_templates.setService_catalog_item( data.service_catalog_item || null, {
            transaction,
        });
        
        await job_templates.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return job_templates;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const job_templatesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                default_price: item.default_price
            ||
            null
            ,
            
                default_duration_minutes: item.default_duration_minutes
            ||
            null
            ,
            
                default_instructions: item.default_instructions
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const job_templates = await db.job_templates.bulkCreate(job_templatesData, { transaction });

        // For each item created, replace relation files
        

        return job_templates;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const job_templates = await db.job_templates.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.default_price !== undefined) updatePayload.default_price = data.default_price;
        
        
        if (data.default_duration_minutes !== undefined) updatePayload.default_duration_minutes = data.default_duration_minutes;
        
        
        if (data.default_instructions !== undefined) updatePayload.default_instructions = data.default_instructions;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await job_templates.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await job_templates.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.service_catalog_item !== undefined) {
            await job_templates.setService_catalog_item(
              
              data.service_catalog_item,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await job_templates.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return job_templates;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_templates = await db.job_templates.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of job_templates) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of job_templates) {
                await record.destroy({transaction});
            }
        });


        return job_templates;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const job_templates = await db.job_templates.findByPk(id, options);

        await job_templates.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await job_templates.destroy({
            transaction
        });

        return job_templates;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const job_templates = await db.job_templates.findOne(
            { where },
            { transaction },
        );

        if (!job_templates) {
            return job_templates;
        }

        const output = job_templates.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.workspace = await job_templates.getWorkspace({
            transaction
        });
        
        
        output.service_catalog_item = await job_templates.getService_catalog_item({
            transaction
        });
        
        
        output.organizations = await job_templates.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.service_catalog_items,
        as: 'service_catalog_item',
        
        where: filter.service_catalog_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.service_catalog_item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.service_catalog_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_templates',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.default_instructions) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_templates',
                        'default_instructions',
                        filter.default_instructions,
                    ),
                };
            }
            

            
            

            
            if (filter.default_priceRange) {
                const [start, end] = filter.default_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    default_price: {
                    ...where.default_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    default_price: {
                    ...where.default_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.default_duration_minutesRange) {
                const [start, end] = filter.default_duration_minutesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    default_duration_minutes: {
                    ...where.default_duration_minutes,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    default_duration_minutes: {
                    ...where.default_duration_minutes,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.job_templates.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'job_templates',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.job_templates.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

